<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">

<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">
<link rel="import" href="/extern/bower_components/vaadin-grid/vaadin-grid.html">

<dom-module id="ts-flashlist">
  <template>
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>

    <style>
:host{display:block}p{font-size:.8em;text-align:center;margin-bottom:0;color:#333232}

</style>

    <auto-update data="{{table}}"
             callback="getTable"
             auto></auto-update>
    <ts-ajax data="{{subtable}}"
             callback="getSubTable"
             parameters='["row", "column"]'
             row="{{row}}"
             column="{{column}}"
             id="ajax_subtable"></ts-ajax>

    <vaadin-grid items="{{realtable.items}}"
                 columns="{{parseColumns(realtable.columns)}}"></vaadin-grid>

    <template is="dom-if" if="[[subtable]]" restamp="true">
      <p>Details for row [[row]], column [[column]]</p>
      <vaadin-grid items="{{subtable.items}}"
                   columns="{{subtable.columns}}"></vaadin-grid>
    </template>

  </template>
  <script>
Polymer({is:"ts-flashlist",properties:{table:{type:Object,observer:"makeRealTable"},realtable:{type:Object,value:function(){return{items:[],columns:[]}}},row:Number,column:String},makeRealTable:function(table){0==this.realtable.columns.length&&this.set("realtable.columns",table.columns),this.set("realtable.items",table.items),this.refreshSubTable()},refreshSubTable:function(){var ajax=this.$.ajax_subtable;void 0!=ajax.row&&ajax.generateRequest()},parseColumns:function(columns){for(var newColumns=[],i=0;i<columns.length;i++){var column=columns[i],newColumn={};switch(newColumn.name=column.name,column.type){case"table":newColumn.renderer=this.subTableRenderer.bind(this);break;case"time":newColumn.renderer=this.timeRenderer.bind(this)}newColumns.push(newColumn)}return newColumns},subTableRenderer:function(cell){if(""==cell.element.innerHTML){var button=document.createElement("paper-button"),icon=document.createElement("iron-icon");icon.icon="open-in-new",button.toggles=!0,button.appendChild(icon),button.row=cell.row.index,button.column=cell.columnName,button.ajax=this.$.ajax_subtable,button.addEventListener("click",this.openSubTable),cell.element.appendChild(button)}},timeRenderer:function(cell){if(""==cell.element.innerHTML){var time=document.createElement("relative-time");time.date=cell.data,cell.element.appendChild(time)}},openSubTable:function(event){var ajax=this.ajax;ajax.row=this.row,ajax.column=this.column,ajax.fire("row-changed",this.row),ajax.fire("column-changed",this.column),ajax.generateRequest()}});
</script>
</dom-module>
